<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>File Manager</title>
</head>
<link href="help.css" type="text/css" rel="stylesheet">
<script type="text/javascript" src="./indexFunctions.js"></script>
<div class="Header">
    <div class="Header">
        <h2 id="title" onclick="goHome()">If I Fits I Sits</h2>
        <div class="nav_bar" id="nav_bar">
            <a class="link" href="index.html">Home</a>&nbsp|&nbsp
            <a class="link" href="FileManager.html">Files</a>&nbsp|&nbsp
            <a class="link" href="Help.html">Help</a>
        </div>
    </div>
</div>
<body>
    <div id="checklist">
        RENDER URL: <a id="render_url" href="https://book-robert.onrender.com/">https://book-robert.onrender.com/</a>
        <h1 id="directory">
            Directory
        </h1>
        <ul>
            <li><a href="#undo_redo_ul">Undo/Redo Pattern</a></li>
            <li><a href="#basic_content">Basic Content (1)</a></li>
            <li><a href="#basic_app_tasks">Basic Application Tasks (2a)</a></li>
            <li><a href="#CSS_rules">CSS rules (2b)</a></li>
            <li><a href="#more_advanced_main_page_options">More Advanced Main Page Options (3a)</a></li>
            <li><a href="#files">Files (3b)</a></li>
            <li><a href="#extensions">Extensions (4)</a></li>
            <li><a href="#usage">Usage</a></li>

        </ul>
        <h1 id="undo_redo_ul">
            Undo/Redo pattern (tier-less)* 30
        </h1>
        <ol type="a">
            <li>
                <a href="./index.html#undo" class="graded">Undo/redo OOP followed></a>
                <p class="description">
                    - The undo/redo OOP can be better seen in the index.js file
                </p></li>
            <li>
                <a href="./index.html#undo" class="graded">Able to do at least 1 undo/redo for change</a>
                <p class="description">
                    - This application has been tested up to a minimum of 10 undo/redo changes
                </p></li>
            <li>
                <a href="./index.html#undo" class="graded">
                    Able to do at least 1 undo/redo for 1 preconfigured change</a>
                <p class="description">
                    - This application has no change with undo/redo when it comes between custom trees, preconfigured <br>
                    trees or uploaded tree files.
                </p></li>
            <li><a href="./index.html#undo" class="graded">
                    Able to do at least 5 undo/redo for change</a>
                <p class="description">
                    - This application is able to do undo/redo a minimum of 10 changes to the main structure
                </p></li>
            <li><a href="./index.html#undo" class="graded">
                    Able to do at least 5 undo/redo for 1 preconfigured change</a>
                <p class="description">
                    - No issues from prev tag
                </p></li>
        </ol>
        <h1 id="basic_content">
            1. Tier: Basic content: 36
        </h1>
        <ol type="a">
            <li><a href="#title">All 3 pages present</a>
                <p class="description">
                    - index.html, FileManagement.html, and Help.html can be accessed from nav bar
                </p></li>
            <li><a href="#title">Header in all pages in correct spot</a>
                <p class="description">
                    - The Header is set to a fixed position on all 3 pages
                </p></li>
            <li><a href="#nav_bar">Nav bar in all pages in correct spot</a>
                <p class="description">
                    - The nav bar is set to a fixed position under the header on all 3 pages
                </p></li>
            <li><a href="./index.html#interaction_buttons">
                All interaction buttons added to main page in correct spot</a>
                <p class="description">
                    - All basic interaction buttons are correct plus some additional buttons
                </p></li>
            <li><a href="./index.html#grid_to_modify">
                Properly display the default content in main page in correct spot</a>
                <p class="description">
                    - On initial launch there will be 3 empty nodes
                </p></li>
            <li><a href="./FileManager.html#file_upload">
                At minimum, a place holder for file upload/load/download in file page in correct spot</a>
                <p class="description">
                    - The file upload bar is at the top and load/download/delete are all connected to the individual <br>
                    file
                </p></li>
            <li><a href="#directory">All headings added to Help page in correct order</a>
                <p class="description">
                    - All headings are in place at the top of the help page
                </p></li>
            <li><a href="#directory">Help page content filled in</a>
                <p class="description">
                    - All Help page is filled in
                </p></li>
            <li><a href="#directory">Within page link help page is working</a>
                <p class="description">
                    - All links in help page link to their respective html tags
                </p></li>
        </ol>
        <h1 id="basic_app_tasks">
            2a. Basic application tasks: 30
        </h1>
        <ol type="a">
            <li><a href="./index.html#grid_to_modify">Able to change components in first row</a>
                <p class="description">
                    - All components on the main structure are able to be changed
                </p></li>
            <li><a href="./index.html#new_row">New row adds a row</a>
                <p class="description">
                    - The new row button acts as intended
                </p></li>
            <li><a href="./index.html#grid_to_modify">Able to change components in new rows</a>
                <p class="description">
                    - All components in new rows act as intended
                </p></li>
        </ol>
        <h1 id="CSS_rules">
            2b. CSS rules: * 18
        </h1>
        <ol type="a">
            <li><a href="#CSS_rules">Background color/image</a>
                <p class="description">
                    - All pages have a custom dark -> lighter gradient as a background
                </p></li>
            <li><a href="#title">CSS header</a>
                <p class="description">
                    - All pages have a header that has custom css formatting
                </p></li>
            <li><a href="#nav_bar">CSS nav bar color/image</a>
                <p class="description">
                    - All pages' nav bar are included in the header and have the custom css formatting
                </p></li>
            <li><a href="#directory">CSS &lt;a&gt; rule</a>
                <p class="description">
                    - All &lt;a&gt; links are have custom rules
                </p></li>
            <li><a href="./FileManager.html#page">Content border</a>
                <p class="description">
                    - There is a content border in the File Manager page, but a border would ruin the effect <br>
                    of the gradient on other pages.
                </p></li>
            <li><a href="#directory">Help heading font change</a>
                <p class="description">
                    - All headings are set to Courier New font, bolded, and a larger font size
                </p></li>
        </ol>
        <h1 id="more_advanced_main_page_options">
            3a. More advanced main page options: * 16
        </h1>
        <ol type="a">
            <li><a href="./index.html#set_poles">Able to change to preconfigured options</a>
                <p class="description">
                    - There are three preconfigured options on the main page: Default (reset), 2x6 poles only, <br>
                    and Mixed
                </p>
            </li>
            <li><a href="./index.html#save_btn">Main content area unaffected by save, and stays on page</a>
                <p class="description">
                    - When saving the site will keep your current layout
                </p></li>
        </ol>
        <h1 id="files">
            3b. Files: 40
        </h1>
        <ol type="a">
            <li><a href="./index.html#save_btn">Able to save the current content (must show in file page)</a>
                <p class="description">
                    - When saving a layout, it will save to a file called save_file.txt
                </p></li>
            <li><a href="./FileManager.html#download_file">Able to download at least one file (default is ok)</a>
                <p class="description">
                    - A user is able to download any files that are uploaded to the serverd
                </p></li>
            <li><a href="./FileManager.html#download_file">Able to download an application generated file</a>
                <p class="description">
                    - Users are able to download the auto generated save_file.txt file
                </p></li>
            <li><a href="./FileManager.html#file_upload">Able to upload a file</a>
                <p class="description">
                    - Users can upload whatever file they like and it will save to the file folder <br>
                    (WARNING the application will have errors if trying to load incorrectly formatted files to the <br>
                    main page)
                </p></li>
            <li><a href="./FileManager.html#load_file">Loading a file redirects back to the main page</a>
                <p class="description">
                    - When loading a correctly formatted file, the server will redirect to the main page with the <br>
                    loaded tree structure
                </p></li>
            <li><a href="./FileManager.html#load_file">Loading properly displays with app generated file</a>
                <p class="description">
                    - When loading the save_file.txt, it will act the same as an uploaded file
                </p></li>
            <li><a href="./FileManager.html#file_list">Able to save, download, upload, and load that same file</a>
                <p class="description">
                    - The save_file.txt acts the same as any other file in the server
                </p></li>
        </ol>
        <h1 id="extensions">
            4. Extensions: 30
        </h1>
        <ol>
            <li><a href="./index.html">Extension: 5 pts fancy page background</a>
                <p class="description">
                - All pages have a fancy gradient background going from a darker color to a lighter in the center
            </p></li>
            <li><a href="./index.html#delete_row">Extension: 5 pts delete row btn</a>
                <p class="description">
                    - There is a button that allows for the deletion of the last row (inverse of add row)
                </p></li>
            <li><a href="#title">Extension: 5 pts CSS Feature not discussed in class </a>
                <p class="description">
                    - Every page on this site have a fixed header that can be accessed from anywhere on the page
                </p></li>
            <li><a href="./FileManager.html#file_list">Extension: 5 pts allow 2 files to be saved, loaded, etc on server</a>
                <p class="description">
                    - Users can upload as many files as they would like to this site and treat them like any other file
                </p></li>
            <li><a href="./FileManager.html#file_list">Extension: 5 pts allow any number of files</a>
                <p class="description">
                    - Explained in prev Extension
                </p></li>
            <li><a href="./FileManager.html#delete_file">Extension: 5 pts delete file from server</a>
                <p class="description">
                    - Users are able to delete any file on the server (If save_file.txt is deleted, it will be <br>
                    auto created when save button is pressed next)
                </p></li>
        </ol>
        <h1 id="usage_header">
            Usage
        </h1>
        <div id="usage">
            <h2 class="usage_headings">Bugs</h2>
            <div class="usage_text">
                There are no bugs to report
            </div>
            <h2 class="usage_headings">Header</h2>
            <div class="usage_text">
                The Header for this site will always appear at the top of your page regardless of how far down you scroll
                and which page you are on (e.g. Home, File, Help). The header allows quick links to all three pages using
                the navigation bar. The Home link will send you to the main page where you can make a cat tree. The Files
                page allows you to see what files the server has, upload/download whatever files you please, and load files
                into a cat tree. The Help page is used to see everything this site contains in both the front end and back
                end. Also Note: the title "If I Fits I Sits" can be selected to quickly return to the home menu.
            </div>
            <h2 class="usage_headings">index.html</h2>
            <div class="usage_text">
                This application is pretty simple to use. On the main page there is a grid that can be resized and is
                supposed to represent a cat tree. The grid size can be modified with the "New Row" and "Delete Row" buttons.
                The content of the tree can be modified either directly by using the three preset buttons ("Reset", "All poles", and
                "Mixed")/clicking the buttons themselves to cycle them through empty -> pole -> house -> empty, or indirectly
                by providing a pattern in the query of the url (ex: <a href="https://book-robert.onrender.com/index.html?0,0,0"
                id="example_url">https://book-robert.onrender.com/index.html?0,0,0</a>).
                The formatting for the patterns will be described later in FileManager.html subheading. All actions can be undone
                and redone using the "Undo" and "Redo" buttons. Finally, the current setup for the cat tree can be saved to the
                server using the "Save" button, which can be loaded later from the File Manager page.
            </div>
            <h2 class="usage_headings">fileManager.html</h2>
            <div class="usage_text">
                This page is used to manage any and all files in the server. To start off, in order for a user to upload
                a file, they must use the provided upload file button. Once a file is uploaded to the server, a user can
                load the file (make the tree on the main page based on the pattern in the file), download a file from the
                server, or delete the file from the server. The pattern formatting for the files and the query in the
                url for the index page is as follows:<br>
                - There are 3 types of nodes allowed: 0 (empty), 1 (pole), 2 (house) <br>
                - There must always be a multiple of 3 nodes in the pattern <br>
                - The pattern is read in left -> right and will be printed left -> right, up -> down <br>
                - Nodes must be separated by a comma (,) with no whitespace <br>
                - Examples: <br>
                - - Default 3 empty: "0,0,0" <br>
                - - All Poles (2x6): "1,1,1,1,1,1" <br>
                - - Mixed preset: "0,0,1,2,0,2,1,2,1" <br>
            </div>
            <h2 class="usage_headings">Help.html</h2>
            <div class="usage_text">
                This page is mostly used as a checklist for the project. At the top there is a directory to quickly access
                all the main grading tiers. In each tier, the checklist items have links to the aspects
                they address. All items include a description of why I felt like I succeeded in that aspect. At the bottom
                is what you are reading now which is a usage document on what this website is and how it works.
            </div>
        </div>
    </div>
</body>